////////////////////////////////////////////////////////////////////////////////
// Filename  : nsfe.h
// File Desc : Nintendo Sixty Four Emulator
// Project   : NSFE (Nintendo Sixty Four Emulator)
// Release   : 0.2a (Developer Release)
// Copyright : NSFE is the Copyright (c) 1999, Brian Faber.  
//
// This software is a Windows implementation of TrueReality, Copyright (C) 1999,
// Niki W. Waibel, and is published under the terms of the GNU General Public 
// License, see below:
// -----------------------------------------------------------------------------
// This program is free software; you can redistribute it and or modify it under
// the terms of the GNU General Public Licence as published by the Free Software
// Foundation; either version 2 of the Licence, or any later version.
//
// This program is distributed in the hope that it will be useful, but WITHOUT
// ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
// FOR A PARTICULAR PURPOSE. See the GNU General Public Licence for more details
//
// You should have received a copy of the GNU General Public Licence along with 
// this program; if not, write to the Free Software Foundation, Inc., 675 Mass 
// Ave, Cambridge, MA 02139, USA.
//
// NSFE Author Information:
//    Brian Faber, Chino, Califorina - USA
//    bevis590@gte.net
//
//    Ben Marsh, Townsville, Queensland - Australia
//    photi@ozemail.com.au
//
// Original TrueReality Author Information:
//    Niki W. Waibel, Reichenau 20, 6890 Lustenau, Austria - EUROPE
//    niki.waibel@xms.net
// -----------------------------------------------------------------------------
// Update History
//
// 00001 16-02-1998 "Initial Code Release.                                     "

#ifndef _NSFE_H_
#define _NSFE_H_


////////////////////////////////////////////////////////////////////////////////
// Include Files


#ifndef _STDSDK_H_
#include "stdsdk.h"                    // Standard Win32 API Includes, etc.
#endif // _STDSDK_H_


////////////////////////////////////////////////////////////////////////////////
// Prototypes

   int WINAPI WinMain( HINSTANCE, HINSTANCE, LPSTR, int );
   LRESULT CALLBACK WindowFunc( HWND, UINT, WPARAM, LPARAM );
   BOOL CALLBACK Quit( HWND, UINT, WPARAM, LPARAM );
   BOOL CALLBACK Exit( HWND, UINT, WPARAM, LPARAM );
   BOOL CALLBACK Syscom( HWND, UINT, WPARAM, LPARAM );


   extern BOOL LoadROMImage( HANDLE );
   extern int DisplayROMProperties( void );
   extern int DisplayAudioProperties( void );
   extern int DisplayVideoProperties( void );
   extern int DisplayControllerProperties( void );
   extern BOOL InitMem( void );
   extern void FreeMem( void );
   extern void InitHardware( void );
   extern DWORD ExecNintendo64( LPVOID );
   extern int RegisterDebugWindow( void );
   extern int MainDebugWindow( void );
   extern BOOL CALLBACK AboutDialog( HWND, UINT, WPARAM, LPARAM );


////////////////////////////////////////////////////////////////////////////////
// Globals

   char szClassName[] = "NSFE";        // Primary Windows Class Name
   char szBuffer[ MAX_PATH ];          // Temporary String Buffer
   HANDLE hInst;                       // Global Application Instance
   HWND hwndMain;                      // Handle to the Main App Window
   DWORD n64Tid;                       // Main N64 Thread ID
   HANDLE hMainThread;                 // Handle to the Main N64 Thread
   HWND hwndMain;                      // Handle to the Main App Window

   extern BOOL inDebugger;             // Is the Debugger Running
   extern    BOOL romLoaded;           // Has the ROM been Loaded ?


#endif // _NSFE_H_